<?php
/* 
   MasterSoft Software Solutions Ltd. - www.mastersoft.at - October. 2009 
   info@mastersoft.at
   This file is licensed under terms of the MPT Open License.
   You can find the license under http://www.mastersoft.at/content/view/26/34/lang,de/    
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');
jimport('joomla.filesystem.folder');
jimport('joomla.filesystem.file');

/**
 * the model class for the file uploader
 * @author <a href="http://www.mastersoft.at" target="_blank">MasterSoft Software Solutions Ltd.</a>
 *
 */
class videosModeluploadfiles extends JModel
{	
	/**
	 * an array of all uploaded files
	 * @var array
	 */
	var $_data;	
	
	/**
	 * get the data array
	 * @return array
	 */
	function &getData()
	{				
		//Lets load the data if it doesn't already exist
		if (empty( $this->_data ))
		{
			$this->getFiles();			
		}

		return $this->_data;
	}
	
	/**
	 * fill the data array
	 * @return void
	 */
	function getFiles()
	{
		$this->_data = array();	
		$flashArray = array();
		$movArray = array();
		$thumbArray = array();
		
		//get flash files
		$sqlQuery = "select * from #__msFiles";
    	$db	= JFactory::getDBO();
    	    					
    	$db->setQuery( $sqlQuery );

		if ($result = $db->query()) 
		{
			$rows = $db->loadRowList();
			foreach($rows as $row)
			{				
				$id = $row[0];
				$path = $row[1];
				$name = JFile::getName($path);				
				$type = $row[2];
				$creationDate = $row[3];
				$timestamp= strtotime($creationDate);
								
				$size = $row[4];
				$url = $row[5];
				
				
				if($type == "flash")
					array_push($flashArray,array($name,$url,$creationDate,$size,$timestamp));
				else if($type == "mov")	
					array_push($movArray,array($name,$url,$creationDate,$size,$timestamp));
				else if($type == "thumb")
					array_push($thumbArray,array($name,$url,$creationDate,$size,$timestamp));
			}
		}
		
		array_push($this->_data,$flashArray);
		array_push($this->_data,$movArray);
		array_push($this->_data,$thumbArray);
	}
	
	/**
	 * delete files from database
	 * @param array $files the files to delete
	 * @param string $type the type(mov,flash,thumb) of the files to delete
	 * @return void
	 */
	function deleteFiles($files,$type)
	{
		
		$diskPath = "";
		
		if($type == "mov")
			$diskPath = JPATH_ROOT.DS.DS ."media" .DS. "mastersoft" .DS . "quicktime";
		else if($type == "thumb")
			$diskPath = JPATH_ROOT.DS.DS ."media" .DS. "mastersoft" .DS . "thumbs";
		else
			$diskPath = JPATH_ROOT.DS.DS ."media" .DS. "mastersoft" .DS . $type;

		$where = "where msvf_path = '";		
		for($i = 0; $i < count($files);$i++)
		{
			$file = $diskPath . DS . $files[$i];
				
			$path = $file;
			JFile::delete($file);
			
			//build where clause for db delete
			if($i == (count($files) - 1))
				$where .= $path . "'";
			else
				$where .= $path ."' OR msvf_path = '";
		}
		
		$sqlQuery = "delete from #__msFiles " .$where ." AND msvf_type = '" .$type ."'";
						
    	$db	= JFactory::getDBO();    	    					
    	$db->setQuery( $sqlQuery );
    	$db->query();
	}
	
	/**
	 * store a file into the database
	 * @param string $name the name of the file
	 * @param string $path the disk path of the file
	 * @param string $type the type(mov,thumb,flash) of the file
	 * @param string $url the url of the file
	 * @return string a success or a error message
	 */
	function storeFileInDB($name,$path,$type,$url)
	{							    				    				    				
		//1. check if there is already a file with the same path in db
    	$sqlQuery = "select * from #__msFiles where msvf_path = '" .$path ."'";
    	$db	= JFactory::getDBO();
    	    					
    	$db->setQuery( $sqlQuery );

		if ($result = $db->query()) 
		{
			//get file attributes														
			$lastModTimeStamp = filectime($path);
			$lastModDate = date("Y-m-d-h-i-s ", $lastModTimeStamp);				
			$fileSize = filesize($path);
				
			if($db->getNumRows($result) > 0)
			{
				//existing entry --> update entry
				//update creation date and size
				$row = $db->loadRow();
				$id = $row[0];
				
				$updateQuery = 
				"update #__msFiles set msvf_creationDate = '" .$lastModDate ."',msvf_size = " .$fileSize ." WHERE msvf_id = " .$id;								
				
				$db->setQuery($updateQuery);
				$db->query();
				
				$msg = $name . 'successfully updated';
				return $msg;								
			}
			else
			{
				//no entry --> insert new																									
				$insertQuery = 
				"insert into #__msFiles (msvf_path,msvf_type,msvf_creationDate,msvf_size,msvf_url) " .
				" VALUES('" .$path ."','" .$type ."','" .$lastModDate ."'," .$fileSize .",'" .$url ."')";
												
				$db->setQuery($insertQuery);
				$db->query();	

				$msg = $name . ' successfully uploaded to server';
				return $msg;		
			}
			
		}	
	}
			
	/**
	 * refresh the database entries with new entries from the disk
	 * @return void
	 */
	function refreshDisk()
	{		
		$diskPath = JPATH_ROOT.DS.DS ."media" .DS. "mastersoft" .DS;
	
		if(JFolder::exists($diskPath ."flash"))
		{
			$files = JFolder::files($diskPath ."flash");
						
			foreach($files as $file)
			{			
				$path = $diskPath ."flash" .DS .$file;
				$url = JURI::root() . "media/mastersoft/flash/" . $file;
				if($this->checkFlash($path))
					$this->storeFileInDB($file,$path,"flash",$url);
				else
					JFile::delete($path);													
			}														
		}
		
		if(JFolder::exists($diskPath ."quicktime"))
		{
			$files = JFolder::files($diskPath ."quicktime");
			
			foreach($files as $file)
			{			
				$path = $diskPath ."quicktime" .DS .$file;
				$url = JURI::root() . "media/mastersoft/quicktime/" . $file;
				if($this->checkMov($path))
					$this->storeFileInDB($file,$path,"mov",$url);
				else
					JFile::delete($path);														
			}		
		}
		
		if(JFolder::exists($diskPath ."thumbs"))
		{
			$files = JFolder::files($diskPath ."thumbs");
			
			foreach($files as $file)
			{			
				$path = $diskPath ."thumbs" .DS .$file;
				$url = JURI::root() . "media/mastersoft/thumbs/" . $file;
				if($this->checkThumb($path))
					$this->storeFileInDB($file,$path,"thumb",$url);
				else
					JFile::delete($path);													
			}
		}			
	}
	
	/**
	 * check if the passed thumb is correct (correct file size,extension, height and width)
	 * @param string $path the path to check
	 * @return boolean true if the thumb is correct.otherwise false
	 */
	function checkThumb($path)
	{								
		$fileSize = filesize($path);
		$imageAttr = getimagesize($path);
		$ext = JFile::getExt($path);		
								
		if( ($fileSize < 4194304)			&&
			($imageAttr[0] <= 170) 			&&
			($imageAttr[1] <= 75)			&&
			($ext == "gif" || $ext == "jpg" || $ext == "jpeg" || $ext == "png"))	   
		{				   		    				    			    			
    		return true;    				
    	}
    	else
    		return false;
					    
	}
	
	/**
	 * check if the passed mov file is correct (extension)
	 * @param string $path the path to check
	 * @return boolean true if the mov file is correct.otherwise false
	 */
	function checkMov($path)
	{	
		$ext = JFile::getExt($path);
		
		if ($ext == "mov" || $ext == "mp4")		   
			return true;
		else
			return false;				  			    			    			     		
	}
	
	/**
	 * check if the passed flash file is correct (extension)
	 * @param string $path the path to check
	 * @return boolean true if the flash file is correct.otherwise false
	 */
	function checkFlash($path)
	{		
		$ext = JFile::getExt($path);
				
		if($ext != "flv" && $ext != "f4v")
    		return false;
    	else
    		return true;		
	}
}
?>
